if Bashmatic.enemies.group then
    -- grouped by areas
    local area = GetRoomAreaName(GetRoomArea(GetPlayerRoom())) or nil
    if area == nil then 
        cecho("<firebrick>Bashmatic: We got an invalid area.\nWe Got: " .. area .. "<reset>")
        return
    end
    if not table.contains(Bashmatic.enemies.targets, area) then
        cecho("<firebrick>Bashmatic: No enemies added from the area " .. area .. "<reset>")
        return
    end
    local size = table.size(Bashmatic.enemies.targets.area)
    if size == 0 then
        cecho("<firebrick>Bashmatic: No enemies added from the area " .. area .. "<reset>")
        return
    end
    if size <= 15 then
        -- fits on one page
        displayAreaTargetList(area, 1, size, nil, nil)
    else
        -- paginator
        local pages = math.floor(size/15)+1
        if tonumber(matches[2]) > pages then 
            cecho("<firebrick>Bashmatic: There aren't that many pages. There are only " .. pages .. " pages.<reset>")
            return
        end
        local startIndex = ((tonumber(matches[2]) - 1)*15)+1
        local endIndex = startIndex + 14
        if endIndex > size then endIndex = size end
        displayAreaTargetList(area, startIndex, endIndex, tonumber(matches[2]), pages)
    end
else
    -- not grouped by area
    local size = table.size(Bashmatic.enemies.targets)
    if size == 0 then
        cecho("<firebrick>Bashmatic: No enemies added.<reset>")
        return
    end
    if size <= 15 then
        -- fits on one page
        displayTargetList(1, size, nil, nil)
    else
        -- paginator
        local pages = math.floor(size/15)+1
        if tonumber(matches[2]) > pages then 
            cecho("<firebrick>Bashmatic: There aren't that many pages. There are only " .. pages .. " pages.<reset>")
            return
        end
        local startIndex = ((tonumber(matches[2]) - 1)*15)+1
        local endIndex = startIndex + 14
        if endIndex > size then endIndex = size end
        displayTargetList(startIndex, endIndex, tonumber(matches[2]), pages)
    end
end